#!-- This file is autogenerated by scripts/ast.b
/**
 * base Decl class
 */
class Decl {
  var doc
}

/**
 * Var Decl representation
 * @serializable
 */
class VarDecl < Decl {

  /**
   * VarDecl(name, value)
   * @constructor
   */
  VarDecl(name, value) {
    self.name = name
    self.value = value
  }

  @to_json() {
    return {
      type: 'VarDecl',
      name: self.name,
      value: self.value,
    }
  }
}

/**
 * Function Decl representation
 * @serializable
 */
class FunctionDecl < Decl {

  /**
   * FunctionDecl(name, params, body)
   * @constructor
   */
  FunctionDecl(name, params, body) {
    self.name = name
    self.params = params
    self.body = body
  }

  @to_json() {
    return {
      type: 'FunctionDecl',
      name: self.name,
      params: self.params,
      body: self.body,
    }
  }
}

/**
 * Method Decl representation
 * @serializable
 */
class MethodDecl < Decl {

  /**
   * MethodDecl(name, params, body, is_static)
   * @constructor
   */
  MethodDecl(name, params, body, is_static) {
    self.name = name
    self.params = params
    self.body = body
    self.is_static = is_static
  }

  @to_json() {
    return {
      type: 'MethodDecl',
      name: self.name,
      params: self.params,
      body: self.body,
      is_static: self.is_static,
    }
  }
}

/**
 * Property Decl representation
 * @serializable
 */
class PropertyDecl < Decl {

  /**
   * PropertyDecl(name, value, is_static)
   * @constructor
   */
  PropertyDecl(name, value, is_static) {
    self.name = name
    self.value = value
    self.is_static = is_static
  }

  @to_json() {
    return {
      type: 'PropertyDecl',
      name: self.name,
      value: self.value,
      is_static: self.is_static,
    }
  }
}

/**
 * Class Decl representation
 * @serializable
 */
class ClassDecl < Decl {

  /**
   * ClassDecl(name, superclass, properties, methods)
   * @constructor
   */
  ClassDecl(name, superclass, properties, methods) {
    self.name = name
    self.superclass = superclass
    self.properties = properties
    self.methods = methods
  }

  @to_json() {
    return {
      type: 'ClassDecl',
      name: self.name,
      superclass: self.superclass,
      properties: self.properties,
      methods: self.methods,
    }
  }
}

